module CrystalValley

using ..Ahorn, Maple

@mapdef Entity "crystal/cutsceneHelper" CutsceneHelper(x::Integer, y::Integer, sceneValue::String="")
@mapdef Entity "crystal/craneLift" CraneLift(x::Integer, y::Integer, spiked::Bool=false, nodes::Array{Tuple{Integer, Integer}, 1}=Tuple{Integer, Integer}[])

const placements = Ahorn.PlacementDict(
	"Cutscene Helper" => Ahorn.EntityPlacement(
		CutsceneHelper
	),
	"Crane Lifter" => Ahorn.EntityPlacement(
		CraneLift
	)
)
Ahorn.nodeLimits(entity::CraneLift) = 0, -1

sprite = "helperimage.png"

function Ahorn.selection(entity::CutsceneHelper)
	x, y = Ahorn.position(entity)
	return Ahorn.getSpriteRectangle("helperimage.png", x, y)
end
function Ahorn.render(ctx::Ahorn.Cairo.CairoContext, entity::CutsceneHelper, room::Maple.Room)
	Ahorn.drawSprite(ctx, "helperimage.png", 0, 0)
end

function Ahorn.selection(entity::CraneLift)

	nodes = get(entity.data, "nodes", ())
    x, y = Ahorn.position(entity)

    res = Ahorn.Rectangle[Ahorn.getSpriteRectangle(sprite, x, y)]
    
    for node in nodes
        nx, ny = Int.(node)

        push!(res, Ahorn.getSpriteRectangle(sprite, nx, ny))
    end

    return res
end
function Ahorn.render(ctx::Ahorn.Cairo.CairoContext, entity::CraneLift, room::Maple.Room)
	Ahorn.drawRectangle(ctx, 0, 0, 48, 4, (0.8, 0.8, 0.8, 1.0), (0.0, 0.0, 0.0, 0.0))
end
function Ahorn.renderSelectedAbs(ctx::Ahorn.Cairo.CairoContext, entity::CraneLift)
    px, py = Ahorn.position(entity)

    for node in get(entity.data, "nodes", ())
        nx, ny = Int.(node)

        theta = atan(py - ny, px - nx)
        Ahorn.drawArrow(ctx, px, py, nx + cos(theta) * 8, ny + sin(theta) * 8, Ahorn.colors.selection_selected_fc, headLength=6)
        Ahorn.drawRectangle(ctx, nx, ny, 48, 4, (0.8, 0.8, 0.8, 1.0), (0.0, 0.0, 0.0, 0.0))

        px, py = nx, ny
    end
end

end